unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Button1: TButton;
    bsave: TButton;
    bload: TButton;
    Button4: TButton;
    Button5: TButton;
    RadioButton1: TRadioButton;
    Label1: TLabel;
    procedure bsaveClick(Sender: TObject);
    procedure bloadClick(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
    FControl:tcomponent;
  public
    { Public declarations }
    procedure ComponentsProc(Component:TComponent);virtual;
    procedure ReadComponents(Stream:TStream);
    procedure WriteComponents(Stream:TStream;Control:TControl);
    procedure FindMethod(Reader: TReader; const MethodName: string;
               var Address: Pointer; var Error: Boolean); virtual;
    procedure CheckName(Reader:TReader; Component:TComponent; var Name:String);
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.bsaveClick(Sender: TObject);
var
  FS:TStream;
  WR:TWriter;
  i:integer;
begin
  FS:=TFileStream.Create('c:\1.dat', fmCreate);
  try
    WR:=TWriter.Create(FS,4096);
    try
      for i:=0 to panel1.ControlCount-1 do
      begin
        WriteComponents(FS,panel1.Controls[i]);
        WR.WriteListEnd;
      end;
    finally
      WR.Free;
    end;
  finally
    FS.Free;
  end;

end;

procedure TForm1.bloadClick(Sender: TObject);
var
  FS:TStream;
  Flag: Boolean;
  RD:TReader;
  i:integer;
begin
  try
    FS:=TFileStream.Create('c:\1.dat', fmOpenRead);
    try
      for i:=panel1.ControlCount-1 downto 0 do begin
        panel1.Controls[i].Free;
      end;
      ReadComponents(fs);
    finally
      FS.Free;
    end;
  except
  end;

end;


procedure TForm1.ComponentsProc(Component: TComponent);
begin
    FControl:=Component;
end;

procedure TForm1.Button4Click(Sender: TObject);
var i:integer;
begin
   for i:=0 to panel1.ControlCount-1 do begin
       panel1.Controls[i].Left:=panel1.Controls[i].Left-10;
       panel1.Controls[i].top:=panel1.Controls[i].top-10;
   end;
end;

procedure TForm1.ReadComponents(Stream: TStream);
var
  RD:TReader;
  i:integer;
begin
    RD:=TReader.Create(Stream,4096);
    try
      RD.Position:=0;
      rd.OnSetName:=checkname;
      RD.OnFindMethod:=FindMethod;
      RD.ReadComponents(self,panel1,ComponentsProc);
    finally
      RD.Free;
    end;

end;

procedure TForm1.writeComponents(Stream:TStream;Control:TControl);
var
  WR:TWriter;
begin
  WR:=TWriter.Create(Stream,4096);
  try
    WR.RootAncestor := nil;
    WR.Ancestor := nil;
    WR.Root := panel1;
    WR.WriteSignature;
    WR.WriteComponent(Control);
  finally
    WR.Free;
  end;
end;


procedure TForm1.FindMethod(Reader: TReader; const MethodName: string;
  var Address: Pointer; var Error: Boolean);
begin
  if Error then
  begin
    Address:=nil;
    Error:=False;
  end;

end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  showmessage ('abc');
end;

procedure TForm1.CheckName(Reader: TReader; Component: TComponent;
  var Name: String);
var
 i:integer;
 S:String;
begin
  i := 0;
  S:=Component.ClassName;
  Delete(S,1,1);
  while self.FindComponent(Name) <> nil do
  begin
    Inc(I);
    Name := Format('%s%d', [S, I]);
  end;

end;

end.
